package it.micegroup.gestioneferie.pianificazioneferie.entity;

import java.io.Serializable;

import javax.validation.constraints.NotNull;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import java.util.Collection;
import java.util.ArrayList;
import javax.persistence.OneToMany;
import javax.persistence.CascadeType;
import com.fasterxml.jackson.annotation.JsonManagedReference;
import lombok.ToString;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;

import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.Getter;
import lombok.AllArgsConstructor;

import javax.persistence.Table;

import org.apache.commons.lang3.StringUtils;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.hibernate.Hibernate;
import java.util.Objects;

import it.micegroup.gestioneferie.libs.entity.BaseEntity;
import it.micegroup.voila2runtime.utils.EntityUtils;

@NoArgsConstructor

@Getter
@Setter
@Entity
@Table(name = "D_STATI_PIANO_FERIE")
public class DstatiPianoFerie extends BaseEntity implements Serializable {

	// Generated SERIAL VERSION UID
	private static final long serialVersionUID = 4210063078L;

	@SuppressWarnings("unused")
	private static final Logger LOGGER = LogManager.getLogger(DstatiPianoFerie.class);

	// ATTRIBUTES
	@NotNull

	@Column(name = "SEQU_ID_STATO_PIANO_FERIE", columnDefinition = "NUMBER(15)")
	private Long sequIdStatoPianoFerie;
	@NotNull

	@Column(name = "CODI_STATO_PIANO_FERIE", columnDefinition = "VARCHAR(50)")
	private String codiStatoPianoFerie;
	@NotNull

	@Column(name = "DESC_STATO_PIANO_FERIE", columnDefinition = "VARCHAR(80)")
	private String descStatoPianoFerie;
	@NotNull

	@Column(name = "UTENTE_ULTIMA_MODIFICA", columnDefinition = "VARCHAR(50)")
	private String utenteUltimaModifica;
	@NotNull

	@Column(name = "DATA_INIZIO_RECORD", columnDefinition = "DATE")
	private Date dataInizioRecord;
	@NotNull

	@Column(name = "DATA_FINE_RECORD", columnDefinition = "DATE")
	private Date dataFineRecord;
	@NotNull

	@Column(name = "DATA_ULTIMA_MODIFICA", columnDefinition = "DATE")
	private Date dataUltimaModifica;
	@NotNull

	@Column(name = "FLAG_ELIMINATO", columnDefinition = "VARCHAR(1)")
	private String flagEliminato;

	// IMPORTED PARENTS

	// CONSTRUCTORS
	public DstatiPianoFerie(String objectKey) {
		super();
		setObjectKey(objectKey);
	}

	public DstatiPianoFerie(DstatiPianoFerieKey dstatiPianoFerieKey, Long sequIdStatoPianoFerie,
			String codiStatoPianoFerie, String descStatoPianoFerie, String utenteUltimaModifica, Date dataInizioRecord,
			Date dataFineRecord, Date dataUltimaModifica, String flagEliminato) {
		super();

		this.dstatiPianoFerieKey = dstatiPianoFerieKey;

		this.sequIdStatoPianoFerie = sequIdStatoPianoFerie;
		this.codiStatoPianoFerie = codiStatoPianoFerie;
		this.descStatoPianoFerie = descStatoPianoFerie;
		this.utenteUltimaModifica = utenteUltimaModifica;
		this.dataInizioRecord = dataInizioRecord;
		this.dataFineRecord = dataFineRecord;
		this.dataUltimaModifica = dataUltimaModifica;
		this.flagEliminato = flagEliminato;
	}

	// CHILDREN
	@JsonProperty(access = Access.WRITE_ONLY)
	@JsonManagedReference("theDstatiPianoFerie")
	@OneToMany(mappedBy = "theDstatiPianoFerie", fetch = FetchType.LAZY, cascade = CascadeType.ALL)
	@ToString.Exclude
	private Collection<DpianiFerie> theDpianiFerie = new ArrayList<>();

	// PARENTS

	// GETTER/SETTER
	/**
	 * @return the sequIdStatoPianoFerie
	 */
	public Long getSequIdStatoPianoFerie() {
		return this.sequIdStatoPianoFerie;
	}

	/**
	 * @param sequIdStatoPianoFerie to set
	 */
	public void setSequIdStatoPianoFerie(Long sequIdStatoPianoFerie) {
		this.sequIdStatoPianoFerie = sequIdStatoPianoFerie;
	}

	/**
	 * @return the codiStatoPianoFerie
	 */
	public String getCodiStatoPianoFerie() {
		return this.codiStatoPianoFerie;
	}

	/**
	 * @param codiStatoPianoFerie to set
	 */
	public void setCodiStatoPianoFerie(String codiStatoPianoFerie) {
		this.codiStatoPianoFerie = codiStatoPianoFerie;
	}

	/**
	 * @return the descStatoPianoFerie
	 */
	public String getDescStatoPianoFerie() {
		return this.descStatoPianoFerie;
	}

	/**
	 * @param descStatoPianoFerie to set
	 */
	public void setDescStatoPianoFerie(String descStatoPianoFerie) {
		this.descStatoPianoFerie = descStatoPianoFerie;
	}

	/**
	 * @return the utenteUltimaModifica
	 */
	public String getUtenteUltimaModifica() {
		return this.utenteUltimaModifica;
	}

	/**
	 * @param utenteUltimaModifica to set
	 */
	public void setUtenteUltimaModifica(String utenteUltimaModifica) {
		this.utenteUltimaModifica = utenteUltimaModifica;
	}

	/**
	 * @return the dataInizioRecord
	 */
	public Date getDataInizioRecord() {
		return this.dataInizioRecord;
	}

	/**
	 * @param dataInizioRecord to set
	 */
	public void setDataInizioRecord(Date dataInizioRecord) {
		this.dataInizioRecord = dataInizioRecord;
	}

	/**
	 * @return the dataFineRecord
	 */
	public Date getDataFineRecord() {
		return this.dataFineRecord;
	}

	/**
	 * @param dataFineRecord to set
	 */
	public void setDataFineRecord(Date dataFineRecord) {
		this.dataFineRecord = dataFineRecord;
	}

	/**
	 * @return the dataUltimaModifica
	 */
	public Date getDataUltimaModifica() {
		return this.dataUltimaModifica;
	}

	/**
	 * @param dataUltimaModifica to set
	 */
	public void setDataUltimaModifica(Date dataUltimaModifica) {
		this.dataUltimaModifica = dataUltimaModifica;
	}

	/**
	 * @return the flagEliminato
	 */
	public String getFlagEliminato() {
		return this.flagEliminato;
	}

	/**
	 * @param flagEliminato to set
	 */
	public void setFlagEliminato(String flagEliminato) {
		this.flagEliminato = flagEliminato;
	}

	// CHILD GETTER/SETTER
	/**
	 * @return the DpianiFerie
	 */
	public Collection<DpianiFerie> getTheDpianiFerie() {
		return theDpianiFerie;
	}

	/**
	 * @param aDpianiFerieList to set
	 */
	public void setTheDpianiFerie(Collection<DpianiFerie> aDpianiFerieList) {
		theDpianiFerie = aDpianiFerieList;
	}

	/// ADD CHILD
	public void addDpianiFerie(DpianiFerie dpianiFerie) {
		theDpianiFerie.add(dpianiFerie);
	}

	// PARENT GETTER/SETTER

	// PARENT ID GETTER/SETTER

	// PARENT OBJECT TITLE

	// PARENT OBJECT KEY

	// IMPORTED PARENT OBJECT KEY

	// OPERATIONS

	// OBJECT KEY
	/**
	 * Restituisce l'identificativo della chiave in formato stringa. Ritorna
	 * conveniente nelle selezioni da lista.
	 * 
	 * @return L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public String getObjectKey() {
		return getObjectKeyById(getDstatiPianoFerieKey());
	}

	public String getObjectKeyById(DstatiPianoFerieKey identification) {
		if (identification == null) {
			return null;
		}
		StringBuilder output = new StringBuilder();
		return output.toString();
	}

	/**
	 * Inizializza la parte identificativa del bean in base alla stringa tokenizzata
	 * da "||" fornita in input.
	 * 
	 * @param key L'identificativo della chiave in formato pk1||pk2||pk3...
	 */
	public void setObjectKey(String key) {
		if (key == null || key.trim().length() == 0) {
			return;
		}
		String[] array = StringUtils.splitByWholeSeparatorPreserveAllTokens(key, getRowIdFieldDelimiter());
		int ctr = 0;

		dstatiPianoFerieKey = new DstatiPianoFerieKey();
	}

	// OBJECT TITLE
	public String getObjectTitle() {
		StringBuilder output = new StringBuilder();
		output.append(getCodiStatoPianoFerie());
		return output.toString();
	}

	// COMPOSITE PRIMARY KEY
	@EmbeddedId
	private DstatiPianoFerieKey dstatiPianoFerieKey;

	// GETTER/SETTER CK
	/**
	 * @return the dstatiPianoFerieKey
	 */
	public DstatiPianoFerieKey getDstatiPianoFerieKey() {
		return this.dstatiPianoFerieKey;
	}

	/**
	 * @param dstatiPianoFerieKey to set
	 */
	public void setDstatiPianoFerieKey(DstatiPianoFerieKey dstatiPianoFerieKey) {
		this.dstatiPianoFerieKey = dstatiPianoFerieKey;
	}

	// COMPOSITE KEY CLASS

	// PREPERSIST
	public void syncCK() {
		if (dstatiPianoFerieKey == null) {
			dstatiPianoFerieKey = new DstatiPianoFerieKey();
		}
	}

	@PrePersist
	public void prePersist() {
		syncCK();
	}

	@PreUpdate
	public void PreUpdate() {
		syncCK();
	}

	// Equals / HashCode
	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o))
			return false;
		DstatiPianoFerie that = (DstatiPianoFerie) o;
		return dstatiPianoFerieKey != null && Objects.equals(dstatiPianoFerieKey, that.dstatiPianoFerieKey);
	}

	@Override
	public int hashCode() {
		return Objects.hash(dstatiPianoFerieKey);
	}
}
